# presentation-forage-models

Augmented.js Presentation LocalForage Models

# API

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [LocalForageCollection](#localforagecollection)
    -   [Parameters](#parameters)
    -   [key](#key)
        -   [Properties](#properties)
    -   [initialize](#initialize)
        -   [Parameters](#parameters-1)
    -   [init](#init)
        -   [Parameters](#parameters-2)
    -   [fetch](#fetch)
        -   [Parameters](#parameters-3)
    -   [save](#save)
        -   [Parameters](#parameters-4)
    -   [update](#update)
        -   [Parameters](#parameters-5)
    -   [destroy](#destroy)
        -   [Parameters](#parameters-6)
    -   [sync](#sync)
        -   [Parameters](#parameters-7)
-   [LocalForage](#localforage)
    -   [isSupported](#issupported)
    -   [getItem](#getitem)
        -   [Parameters](#parameters-8)
    -   [setItem](#setitem)
        -   [Parameters](#parameters-9)
    -   [removeItem](#removeitem)
        -   [Parameters](#parameters-10)
    -   [clear](#clear)
    -   [key](#key-1)
        -   [Parameters](#parameters-11)
    -   [keys](#keys)
    -   [length](#length)
-   [LocalForageModel](#localforagemodel)
    -   [Parameters](#parameters-12)
    -   [fetch](#fetch-1)
        -   [Parameters](#parameters-13)
    -   [save](#save-1)
        -   [Parameters](#parameters-14)
    -   [update](#update-1)
        -   [Parameters](#parameters-15)
    -   [destroy](#destroy-1)
        -   [Parameters](#parameters-16)
-   [sync](#sync-1)

## LocalForageCollection

**Extends AbstractCollection**

LocalForageCollection

### Parameters

-   `models`  
-   `options`  

### key

Base key name for the collection (simular to url for rest-based)

#### Properties

-   `key` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The key

### initialize

Initialize the model with needed wireing

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### init

Custom init method for the model (called at inititlize)

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### fetch

Fetch the collection

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### save

Save the collection

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### update

Update the collection

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### destroy

Destroy the collection

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### sync

Sync method for Collection

#### Parameters

-   `method`  
-   `model`  
-   `options`  

## LocalForage

LocalForage API

### isSupported

Is storage supported

Returns **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Returns true if supported

### getItem

Gets an item from storage

#### Parameters

-   `itemKey`  
-   `key` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The key in storage

Returns **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Returns object from storage

### setItem

Sets an item to storage

#### Parameters

-   `itemKey`  
-   `object` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** The data to set
-   `key` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The key in storage

### removeItem

Removes an item from storage

#### Parameters

-   `itemKey`  
-   `key` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The key in storage

### clear

Clears storage

### key

Gets the key from storage for index

#### Parameters

-   `i` **[number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The index in storage

Returns **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Returns the key from storage

### keys

Gets the keya from storage

Returns **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Returns the keys from storage

### length

The length of storage by keys

Returns **[number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** Returns the length of storage by keys

## LocalForageModel

**Extends Augmented.AbstractModel**

Model

### Parameters

-   `attributes`  
-   `options`  
-   `args` **...any** 

### fetch

Fetch the model

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### save

Save the model

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### update

Update the model

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

### destroy

Destroy the model

#### Parameters

-   `options` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Any options to pass

## sync

sync - Sync model data to bound localforage
